local fps = {
  frames_this_second = 0,
  fps = 0,
  acc_time = 0,
  seconds = 0,
  average = 0,
}

function fps.update(fps, dt)
  fps.acc_time = fps.acc_time + dt
  if fps.acc_time > 1 then
    -- roll over to next second
    fps.acc_time = fps.acc_time - 1
    fps.fps = fps.frames_this_second
    fps.frames_this_second = 0
    fps.seconds = fps.seconds + 1
    fps.average = fps.average * ((fps.seconds - 1)/fps.seconds) +
                  fps.fps * (1/fps.seconds)
  end
  fps.frames_this_second = fps.frames_this_second + 1
end

return fps
